<?php

namespace WPT_Divi_Gravity_Modules\GravityFormModule;

/**
 * .
 */
class Fields
{
    protected  $container ;
    /**
     * Constructor.
     */
    public function __construct( $container )
    {
        $this->container = $container;
    }
    
    public function checkbox_radio_field_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function confirmation_message_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function consent_checkbox_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function consent_description_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function description_fields()
    {
        $fields = [];
        return $fields;
    }
    
    /**
     * Field container
     */
    public function field_container_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function field_description_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function field_validation_error_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function footer_fields()
    {
        $fields = [];
        return $fields;
    }
    
    /**
     * Get default for given keys
     */
    public function get_default( $key )
    {
        $defaults = $this->get_defaults();
        return ( isset( $defaults[$key] ) ? $defaults[$key] : '' );
    }
    
    /**
     * Get defaults
     */
    public function get_defaults()
    {
        $defaults = [
            'gravityform_id' => 'gf-0',
            'title'          => 'on',
            'description'    => 'on',
            'ajax'           => 'off',
            'tabindex'       => '0',
            'field_values'   => '',
        ];
        return $defaults;
    }
    
    /**
     * Get module fields
     */
    public function get_fields()
    {
        $fields = [];
        $fields['admin_label'] = [
            'label'       => __( 'Admin Label', 'et_builder' ),
            'type'        => 'text',
            'description' => 'This will change the label of the module in the builder for easy identification.',
        ];
        return $fields + $this->get_gravityform_shortcode_param_fields() + $this->footer_fields() + $this->description_fields() + $this->field_container_fields() + $this->input_container_fields() + $this->consent_description_fields() + $this->consent_checkbox_fields() + $this->input_general_fields() + $this->text_input_fields() + $this->select_field_fields() + $this->checkbox_radio_field_fields() + $this->label_fields() + $this->sub_label_fields() + $this->field_description_fields() + $this->validation_error_heading_fields() + $this->field_validation_error_fields() + $this->confirmation_message_fields() + $this->progress_bar_title_fields() + $this->progress_bar_fields() + $this->section_field_title() + $this->section_field_description() + $this->section_field() + $this->title_fields();
    }
    
    public function get_gravityform_shortcode_param_fields()
    {
        $fields = [];
        $fields['gravityform_id'] = [
            'label'       => esc_html__( 'Form ID', 'et_builder' ),
            'type'        => 'select',
            'options'     => $this->container['gravityform']->get_active_form_options(),
            'tab_slug'    => 'general',
            'toggle_slug' => 'main_content',
            'description' => esc_html__( 'Select the gravity form', 'et_builder' ),
            'default'     => $this->get_default( 'gravityform_id' ),
        ];
        $fields['title'] = [
            'label'       => esc_html__( 'Show Title', 'et_builder' ),
            'type'        => 'yes_no_button',
            'options'     => [
            'off' => esc_html__( 'Off', 'et_builder' ),
            'on'  => esc_html__( 'On', 'et_builder' ),
        ],
            'tab_slug'    => 'general',
            'toggle_slug' => 'main_content',
            'description' => esc_html__( 'Select `Yes` to show title', 'et_builder' ),
            'default'     => $this->get_default( 'title' ),
        ];
        $fields['description'] = [
            'label'       => esc_html__( 'Show Description', 'et_builder' ),
            'type'        => 'yes_no_button',
            'options'     => [
            'off' => esc_html__( 'Off', 'et_builder' ),
            'on'  => esc_html__( 'On', 'et_builder' ),
        ],
            'tab_slug'    => 'general',
            'toggle_slug' => 'main_content',
            'description' => esc_html__( 'Select `Yes` to show description', 'et_builder' ),
            'default'     => $this->get_default( 'description' ),
        ];
        $fields['ajax'] = [
            'label'       => esc_html__( 'Enable Ajax', 'et_builder' ),
            'type'        => 'yes_no_button',
            'options'     => [
            'off' => esc_html__( 'Off', 'et_builder' ),
            'on'  => esc_html__( 'On', 'et_builder' ),
        ],
            'tab_slug'    => 'general',
            'toggle_slug' => 'main_content',
            'description' => esc_html__( 'Select `Yes` to submit form via ajax', 'et_builder' ),
            'default'     => $this->get_default( 'ajax' ),
        ];
        $fields['tabindex'] = [
            'label'          => esc_html__( 'Tab Index', 'et_builder' ),
            'type'           => 'range',
            'range_settings' => [
            'min'  => 0,
            'max'  => 100,
            'step' => 1,
        ],
            'tab_slug'       => 'general',
            'toggle_slug'    => 'main_content',
            'description'    => esc_html__( 'Specify the starting tab index for the fields of this form.', 'et_builder' ),
            'allowed_units'  => [ '' ],
            'default_unit'   => '',
            'default'        => $this->get_default( 'tabindex' ),
        ];
        $fields['field_values'] = [
            'label'       => esc_html__( 'Field Values', 'et_builder' ),
            'type'        => 'text',
            'tab_slug'    => 'general',
            'toggle_slug' => 'main_content',
            'description' => esc_html__( 'Specify the default field values. Example: field_values=’check=First Choice,Second Choice’.', 'et_builder' ),
            'default'     => $this->get_default( 'field_values' ),
        ];
        return $fields;
    }
    
    /**
     * Input container
     */
    public function input_container_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function input_general_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function label_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function progress_bar_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function progress_bar_title_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function section_field()
    {
        $fields = [];
        return $fields;
    }
    
    public function section_field_description()
    {
        $fields = [];
        return $fields;
    }
    
    public function section_field_title()
    {
        $fields = [];
        return $fields;
    }
    
    public function select_field_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function sub_label_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function text_input_fields()
    {
        $fields = [];
        return $fields;
    }
    
    /**
     * Title fields
     */
    public function title_fields()
    {
        $fields = [];
        return $fields;
    }
    
    public function validation_error_heading_fields()
    {
        $fields = [];
        return $fields;
    }

}