<?php

namespace WPT\DiviGravity\Divi;

use  WPT_Divi_Gravity_Modules\GravityFormExtension ;
use  WPT_Divi_Gravity_Modules\GravityFormModule\GravityFormModule ;
/**
 * Divi.
 */
class Divi
{
    protected  $container ;
    /**
     * Constructor.
     */
    public function __construct( $container )
    {
        $this->container = $container;
    }
    
    /**
     * Register divi extension
     *
     * @return [type] [description]
     */
    public function divi_extensions_init()
    {
        new GravityFormExtension( $this->container );
    }
    
    /**
     * Enqueue assets for divi modules
     */
    public function enqueue_divi_module_assets()
    {
        if ( isset( $_GET['et_fb'] ) and $_GET['et_fb'] == '1' ) {
            $this->enqueue_et_pb_wpt_gravityform_assets();
        }
    }
    
    /**
     * Load assets for the carousel image.
     */
    public function enqueue_et_pb_wpt_gravityform_assets()
    {
        wp_enqueue_style( 'gforms_formsmain_css' );
        wp_enqueue_style( 'gforms_ready_class_css' );
        wp_enqueue_style( 'gforms_browsers_css' );
        if ( is_rtl() ) {
            wp_enqueue_style( 'gforms_rtl_css' );
        }
    }
    
    /**
     * ET builder ready hook
     *
     * @return [type] [description]
     */
    public function et_builder_ready()
    {
        new GravityFormModule( $this->container );
    }

}